/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.7
        Device            :  PIC18F57Q43
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.31 and above
        MPLAB 	          :  MPLAB X 5.45	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set Blue aliases
#define Blue_TRIS                 TRISBbits.TRISB2
#define Blue_LAT                  LATBbits.LATB2
#define Blue_PORT                 PORTBbits.RB2
#define Blue_WPU                  WPUBbits.WPUB2
#define Blue_OD                   ODCONBbits.ODCB2
#define Blue_ANS                  ANSELBbits.ANSELB2
#define Blue_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define Blue_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define Blue_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define Blue_GetValue()           PORTBbits.RB2
#define Blue_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define Blue_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define Blue_SetPullup()          do { WPUBbits.WPUB2 = 1; } while(0)
#define Blue_ResetPullup()        do { WPUBbits.WPUB2 = 0; } while(0)
#define Blue_SetPushPull()        do { ODCONBbits.ODCB2 = 0; } while(0)
#define Blue_SetOpenDrain()       do { ODCONBbits.ODCB2 = 1; } while(0)
#define Blue_SetAnalogMode()      do { ANSELBbits.ANSELB2 = 1; } while(0)
#define Blue_SetDigitalMode()     do { ANSELBbits.ANSELB2 = 0; } while(0)

// get/set Red aliases
#define Red_TRIS                 TRISCbits.TRISC4
#define Red_LAT                  LATCbits.LATC4
#define Red_PORT                 PORTCbits.RC4
#define Red_WPU                  WPUCbits.WPUC4
#define Red_OD                   ODCONCbits.ODCC4
#define Red_ANS                  ANSELCbits.ANSELC4
#define Red_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define Red_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define Red_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define Red_GetValue()           PORTCbits.RC4
#define Red_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define Red_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define Red_SetPullup()          do { WPUCbits.WPUC4 = 1; } while(0)
#define Red_ResetPullup()        do { WPUCbits.WPUC4 = 0; } while(0)
#define Red_SetPushPull()        do { ODCONCbits.ODCC4 = 0; } while(0)
#define Red_SetOpenDrain()       do { ODCONCbits.ODCC4 = 1; } while(0)
#define Red_SetAnalogMode()      do { ANSELCbits.ANSELC4 = 1; } while(0)
#define Red_SetDigitalMode()     do { ANSELCbits.ANSELC4 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/