/***********************************************
 *   File System Test Program
 *   microSD Click Board  PIC18F57Q43 
***********************************************/
#include "mcc_generated_files/mcc.h"
#include <stdlib.h>

// File Systme@ϐ
FRESULT result;
FATFS drive;
FIL file;
// Avϐ
uint16_t Length[2], Flag, Counter;
char Buffer[256], State;
char Msg[9] = "xxxxxxx,";
// Xe[gϐ`
enum TaskState{
    WAIT_SW,
    MOUNT,
    W_OPEN,
    SD_WRITE,
    R_OPEN,
    SD_READ,
    ALL_END,
};

/********************************
 * ^C}0 荞ݏ֐
 *******************************/
void TMR0_Process(void){
    Flag = 1;           // tOI
}

/****** C֐ ************/
void main(void)
{
    SYSTEM_Initialize();                         // VXe
    State = WAIT_SW;                             // Xe[g
    // ^C}0 Calback֐`
    TMR0_SetInterruptHandler(TMR0_Process); 
    printf("\r\nPush SW0 to Start!!\r\n");      // JnbZ[W
    // 荞݋
    INTERRUPT_GlobalInterruptEnable();           // 荞݋
    /***** C[v ***********/
    while(1){
        switch(State){
            case WAIT_SW:                               // SW0I҂
                if(SW0_GetValue() == 0){
                    while(SW0_GetValue() == 0);         // `b^
                    State = MOUNT;                      // eXgJn
                    printf("Start SD Card Test!!\r\n");                     
                }
                break;
            case MOUNT:                                 // }Eg               
                // J[h}Eg
                if(f_mount(&drive,"0:",1) != FR_OK){    // }Egł܂                
                    LED_Toggle();                       // ڈ 
                    printf("Not Mounted\r\n");
                    __delay_ms(200);                    // x
                }
                else                                    // }Eg
                    State = W_OPEN;                     // I[v
                break;
            case W_OPEN:
                 // t@CI[v@ǋL̏݃[h
                if(f_open(&file, "LOGDATA.TXT",  FA_WRITE | FA_OPEN_APPEND) == FR_OK)
                    State = SD_WRITE;
                break;
            case SD_WRITE:                              // ݊Jn
                if(Flag == 1){                          // tOȈꍇ
                    Flag = 0;                           // tOZbg       
                    Counter += 1;                       // JEglAbv
                    sprintf(Msg, "%07d,", Counter);     // ɕϊ
                    LED_Toggle();                       // ڈ
                    // f[^ݎs@̍Ō0x00
                    f_write(&file, Msg, sizeof(Msg)-1, &Length);           
                }
                // ݏI`FbN
                if(SW0_GetValue() == 0){                // SW0I
                    f_close(&file);                     // t@CN[Y
                    State = R_OPEN;                     // ǂݏoeXg                  
                }
                break;
            case R_OPEN:                                // t@CăI[v
                if(f_open(&file, "LOGDATA.TXT",  FA_READ) == FR_OK)
                    State = SD_READ;                    // ǂݏo
                break;
            case SD_READ:                               // ǂݏoeXg
                f_read(&file, Buffer, 64, Length);      // 64oCgǂݏo
                Buffer[Length[0]] = 0;                  // Ō̃}[N
                printf(Buffer);                         // PC֑M
                printf("\r\n");                        // s
                if(Length[0] == 0)                      // t@CȈꍇ
                    State = ALL_END;                    // I
                break;
            case ALL_END:                               // I
                f_close(&file);                         // t@CN[Y
                f_mount(0, "0:", 0);                    // A}Eg
                printf("\r\nFile Write/Read End!!");   // bZ[W
                State = WAIT_SW;                        // ŏցiJԂeXgj
                break;
            default:
                break;
        }
    }
}