/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.7
        Device            :  PIC18F27Q43
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.31 and above
        MPLAB 	          :  MPLAB X 5.45	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set Next aliases
#define Next_TRIS                 TRISAbits.TRISA0
#define Next_LAT                  LATAbits.LATA0
#define Next_PORT                 PORTAbits.RA0
#define Next_WPU                  WPUAbits.WPUA0
#define Next_OD                   ODCONAbits.ODCA0
#define Next_ANS                  ANSELAbits.ANSELA0
#define Next_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define Next_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define Next_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define Next_GetValue()           PORTAbits.RA0
#define Next_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define Next_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define Next_SetPullup()          do { WPUAbits.WPUA0 = 1; } while(0)
#define Next_ResetPullup()        do { WPUAbits.WPUA0 = 0; } while(0)
#define Next_SetPushPull()        do { ODCONAbits.ODCA0 = 0; } while(0)
#define Next_SetOpenDrain()       do { ODCONAbits.ODCA0 = 1; } while(0)
#define Next_SetAnalogMode()      do { ANSELAbits.ANSELA0 = 1; } while(0)
#define Next_SetDigitalMode()     do { ANSELAbits.ANSELA0 = 0; } while(0)

// get/set Up aliases
#define Up_TRIS                 TRISAbits.TRISA1
#define Up_LAT                  LATAbits.LATA1
#define Up_PORT                 PORTAbits.RA1
#define Up_WPU                  WPUAbits.WPUA1
#define Up_OD                   ODCONAbits.ODCA1
#define Up_ANS                  ANSELAbits.ANSELA1
#define Up_SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define Up_SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define Up_Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define Up_GetValue()           PORTAbits.RA1
#define Up_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define Up_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define Up_SetPullup()          do { WPUAbits.WPUA1 = 1; } while(0)
#define Up_ResetPullup()        do { WPUAbits.WPUA1 = 0; } while(0)
#define Up_SetPushPull()        do { ODCONAbits.ODCA1 = 0; } while(0)
#define Up_SetOpenDrain()       do { ODCONAbits.ODCA1 = 1; } while(0)
#define Up_SetAnalogMode()      do { ANSELAbits.ANSELA1 = 1; } while(0)
#define Up_SetDigitalMode()     do { ANSELAbits.ANSELA1 = 0; } while(0)

// get/set Down aliases
#define Down_TRIS                 TRISAbits.TRISA2
#define Down_LAT                  LATAbits.LATA2
#define Down_PORT                 PORTAbits.RA2
#define Down_WPU                  WPUAbits.WPUA2
#define Down_OD                   ODCONAbits.ODCA2
#define Down_ANS                  ANSELAbits.ANSELA2
#define Down_SetHigh()            do { LATAbits.LATA2 = 1; } while(0)
#define Down_SetLow()             do { LATAbits.LATA2 = 0; } while(0)
#define Down_Toggle()             do { LATAbits.LATA2 = ~LATAbits.LATA2; } while(0)
#define Down_GetValue()           PORTAbits.RA2
#define Down_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define Down_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define Down_SetPullup()          do { WPUAbits.WPUA2 = 1; } while(0)
#define Down_ResetPullup()        do { WPUAbits.WPUA2 = 0; } while(0)
#define Down_SetPushPull()        do { ODCONAbits.ODCA2 = 0; } while(0)
#define Down_SetOpenDrain()       do { ODCONAbits.ODCA2 = 1; } while(0)
#define Down_SetAnalogMode()      do { ANSELAbits.ANSELA2 = 1; } while(0)
#define Down_SetDigitalMode()     do { ANSELAbits.ANSELA2 = 0; } while(0)

// get/set DC aliases
#define DC_TRIS                 TRISAbits.TRISA3
#define DC_LAT                  LATAbits.LATA3
#define DC_PORT                 PORTAbits.RA3
#define DC_WPU                  WPUAbits.WPUA3
#define DC_OD                   ODCONAbits.ODCA3
#define DC_ANS                  ANSELAbits.ANSELA3
#define DC_SetHigh()            do { LATAbits.LATA3 = 1; } while(0)
#define DC_SetLow()             do { LATAbits.LATA3 = 0; } while(0)
#define DC_Toggle()             do { LATAbits.LATA3 = ~LATAbits.LATA3; } while(0)
#define DC_GetValue()           PORTAbits.RA3
#define DC_SetDigitalInput()    do { TRISAbits.TRISA3 = 1; } while(0)
#define DC_SetDigitalOutput()   do { TRISAbits.TRISA3 = 0; } while(0)
#define DC_SetPullup()          do { WPUAbits.WPUA3 = 1; } while(0)
#define DC_ResetPullup()        do { WPUAbits.WPUA3 = 0; } while(0)
#define DC_SetPushPull()        do { ODCONAbits.ODCA3 = 0; } while(0)
#define DC_SetOpenDrain()       do { ODCONAbits.ODCA3 = 1; } while(0)
#define DC_SetAnalogMode()      do { ANSELAbits.ANSELA3 = 1; } while(0)
#define DC_SetDigitalMode()     do { ANSELAbits.ANSELA3 = 0; } while(0)

// get/set RES aliases
#define RES_TRIS                 TRISAbits.TRISA4
#define RES_LAT                  LATAbits.LATA4
#define RES_PORT                 PORTAbits.RA4
#define RES_WPU                  WPUAbits.WPUA4
#define RES_OD                   ODCONAbits.ODCA4
#define RES_ANS                  ANSELAbits.ANSELA4
#define RES_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define RES_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define RES_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define RES_GetValue()           PORTAbits.RA4
#define RES_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define RES_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)
#define RES_SetPullup()          do { WPUAbits.WPUA4 = 1; } while(0)
#define RES_ResetPullup()        do { WPUAbits.WPUA4 = 0; } while(0)
#define RES_SetPushPull()        do { ODCONAbits.ODCA4 = 0; } while(0)
#define RES_SetOpenDrain()       do { ODCONAbits.ODCA4 = 1; } while(0)
#define RES_SetAnalogMode()      do { ANSELAbits.ANSELA4 = 1; } while(0)
#define RES_SetDigitalMode()     do { ANSELAbits.ANSELA4 = 0; } while(0)

// get/set Blue aliases
#define Blue_TRIS                 TRISAbits.TRISA6
#define Blue_LAT                  LATAbits.LATA6
#define Blue_PORT                 PORTAbits.RA6
#define Blue_WPU                  WPUAbits.WPUA6
#define Blue_OD                   ODCONAbits.ODCA6
#define Blue_ANS                  ANSELAbits.ANSELA6
#define Blue_SetHigh()            do { LATAbits.LATA6 = 1; } while(0)
#define Blue_SetLow()             do { LATAbits.LATA6 = 0; } while(0)
#define Blue_Toggle()             do { LATAbits.LATA6 = ~LATAbits.LATA6; } while(0)
#define Blue_GetValue()           PORTAbits.RA6
#define Blue_SetDigitalInput()    do { TRISAbits.TRISA6 = 1; } while(0)
#define Blue_SetDigitalOutput()   do { TRISAbits.TRISA6 = 0; } while(0)
#define Blue_SetPullup()          do { WPUAbits.WPUA6 = 1; } while(0)
#define Blue_ResetPullup()        do { WPUAbits.WPUA6 = 0; } while(0)
#define Blue_SetPushPull()        do { ODCONAbits.ODCA6 = 0; } while(0)
#define Blue_SetOpenDrain()       do { ODCONAbits.ODCA6 = 1; } while(0)
#define Blue_SetAnalogMode()      do { ANSELAbits.ANSELA6 = 1; } while(0)
#define Blue_SetDigitalMode()     do { ANSELAbits.ANSELA6 = 0; } while(0)

// get/set Red aliases
#define Red_TRIS                 TRISAbits.TRISA7
#define Red_LAT                  LATAbits.LATA7
#define Red_PORT                 PORTAbits.RA7
#define Red_WPU                  WPUAbits.WPUA7
#define Red_OD                   ODCONAbits.ODCA7
#define Red_ANS                  ANSELAbits.ANSELA7
#define Red_SetHigh()            do { LATAbits.LATA7 = 1; } while(0)
#define Red_SetLow()             do { LATAbits.LATA7 = 0; } while(0)
#define Red_Toggle()             do { LATAbits.LATA7 = ~LATAbits.LATA7; } while(0)
#define Red_GetValue()           PORTAbits.RA7
#define Red_SetDigitalInput()    do { TRISAbits.TRISA7 = 1; } while(0)
#define Red_SetDigitalOutput()   do { TRISAbits.TRISA7 = 0; } while(0)
#define Red_SetPullup()          do { WPUAbits.WPUA7 = 1; } while(0)
#define Red_ResetPullup()        do { WPUAbits.WPUA7 = 0; } while(0)
#define Red_SetPushPull()        do { ODCONAbits.ODCA7 = 0; } while(0)
#define Red_SetOpenDrain()       do { ODCONAbits.ODCA7 = 1; } while(0)
#define Red_SetAnalogMode()      do { ANSELAbits.ANSELA7 = 1; } while(0)
#define Red_SetDigitalMode()     do { ANSELAbits.ANSELA7 = 0; } while(0)

// get/set RB0 procedures
#define RB0_SetHigh()            do { LATBbits.LATB0 = 1; } while(0)
#define RB0_SetLow()             do { LATBbits.LATB0 = 0; } while(0)
#define RB0_Toggle()             do { LATBbits.LATB0 = ~LATBbits.LATB0; } while(0)
#define RB0_GetValue()              PORTBbits.RB0
#define RB0_SetDigitalInput()    do { TRISBbits.TRISB0 = 1; } while(0)
#define RB0_SetDigitalOutput()   do { TRISBbits.TRISB0 = 0; } while(0)
#define RB0_SetPullup()             do { WPUBbits.WPUB0 = 1; } while(0)
#define RB0_ResetPullup()           do { WPUBbits.WPUB0 = 0; } while(0)
#define RB0_SetAnalogMode()         do { ANSELBbits.ANSELB0 = 1; } while(0)
#define RB0_SetDigitalMode()        do { ANSELBbits.ANSELB0 = 0; } while(0)

// get/set RB1 procedures
#define RB1_SetHigh()            do { LATBbits.LATB1 = 1; } while(0)
#define RB1_SetLow()             do { LATBbits.LATB1 = 0; } while(0)
#define RB1_Toggle()             do { LATBbits.LATB1 = ~LATBbits.LATB1; } while(0)
#define RB1_GetValue()              PORTBbits.RB1
#define RB1_SetDigitalInput()    do { TRISBbits.TRISB1 = 1; } while(0)
#define RB1_SetDigitalOutput()   do { TRISBbits.TRISB1 = 0; } while(0)
#define RB1_SetPullup()             do { WPUBbits.WPUB1 = 1; } while(0)
#define RB1_ResetPullup()           do { WPUBbits.WPUB1 = 0; } while(0)
#define RB1_SetAnalogMode()         do { ANSELBbits.ANSELB1 = 1; } while(0)
#define RB1_SetDigitalMode()        do { ANSELBbits.ANSELB1 = 0; } while(0)

// get/set RB2 procedures
#define RB2_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define RB2_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define RB2_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define RB2_GetValue()              PORTBbits.RB2
#define RB2_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define RB2_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define RB2_SetPullup()             do { WPUBbits.WPUB2 = 1; } while(0)
#define RB2_ResetPullup()           do { WPUBbits.WPUB2 = 0; } while(0)
#define RB2_SetAnalogMode()         do { ANSELBbits.ANSELB2 = 1; } while(0)
#define RB2_SetDigitalMode()        do { ANSELBbits.ANSELB2 = 0; } while(0)

// get/set CS aliases
#define CS_TRIS                 TRISBbits.TRISB3
#define CS_LAT                  LATBbits.LATB3
#define CS_PORT                 PORTBbits.RB3
#define CS_WPU                  WPUBbits.WPUB3
#define CS_OD                   ODCONBbits.ODCB3
#define CS_ANS                  ANSELBbits.ANSELB3
#define CS_SetHigh()            do { LATBbits.LATB3 = 1; } while(0)
#define CS_SetLow()             do { LATBbits.LATB3 = 0; } while(0)
#define CS_Toggle()             do { LATBbits.LATB3 = ~LATBbits.LATB3; } while(0)
#define CS_GetValue()           PORTBbits.RB3
#define CS_SetDigitalInput()    do { TRISBbits.TRISB3 = 1; } while(0)
#define CS_SetDigitalOutput()   do { TRISBbits.TRISB3 = 0; } while(0)
#define CS_SetPullup()          do { WPUBbits.WPUB3 = 1; } while(0)
#define CS_ResetPullup()        do { WPUBbits.WPUB3 = 0; } while(0)
#define CS_SetPushPull()        do { ODCONBbits.ODCB3 = 0; } while(0)
#define CS_SetOpenDrain()       do { ODCONBbits.ODCB3 = 1; } while(0)
#define CS_SetAnalogMode()      do { ANSELBbits.ANSELB3 = 1; } while(0)
#define CS_SetDigitalMode()     do { ANSELBbits.ANSELB3 = 0; } while(0)

// get/set SDO aliases
#define SDO_TRIS                 TRISBbits.TRISB4
#define SDO_LAT                  LATBbits.LATB4
#define SDO_PORT                 PORTBbits.RB4
#define SDO_WPU                  WPUBbits.WPUB4
#define SDO_OD                   ODCONBbits.ODCB4
#define SDO_ANS                  ANSELBbits.ANSELB4
#define SDO_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define SDO_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define SDO_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define SDO_GetValue()           PORTBbits.RB4
#define SDO_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define SDO_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define SDO_SetPullup()          do { WPUBbits.WPUB4 = 1; } while(0)
#define SDO_ResetPullup()        do { WPUBbits.WPUB4 = 0; } while(0)
#define SDO_SetPushPull()        do { ODCONBbits.ODCB4 = 0; } while(0)
#define SDO_SetOpenDrain()       do { ODCONBbits.ODCB4 = 1; } while(0)
#define SDO_SetAnalogMode()      do { ANSELBbits.ANSELB4 = 1; } while(0)
#define SDO_SetDigitalMode()     do { ANSELBbits.ANSELB4 = 0; } while(0)

// get/set SCK aliases
#define SCK_TRIS                 TRISBbits.TRISB5
#define SCK_LAT                  LATBbits.LATB5
#define SCK_PORT                 PORTBbits.RB5
#define SCK_WPU                  WPUBbits.WPUB5
#define SCK_OD                   ODCONBbits.ODCB5
#define SCK_ANS                  ANSELBbits.ANSELB5
#define SCK_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define SCK_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define SCK_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define SCK_GetValue()           PORTBbits.RB5
#define SCK_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define SCK_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)
#define SCK_SetPullup()          do { WPUBbits.WPUB5 = 1; } while(0)
#define SCK_ResetPullup()        do { WPUBbits.WPUB5 = 0; } while(0)
#define SCK_SetPushPull()        do { ODCONBbits.ODCB5 = 0; } while(0)
#define SCK_SetOpenDrain()       do { ODCONBbits.ODCB5 = 1; } while(0)
#define SCK_SetAnalogMode()      do { ANSELBbits.ANSELB5 = 1; } while(0)
#define SCK_SetDigitalMode()     do { ANSELBbits.ANSELB5 = 0; } while(0)

// get/set SDCard_CS aliases
#define SDCard_CS_TRIS                 TRISCbits.TRISC0
#define SDCard_CS_LAT                  LATCbits.LATC0
#define SDCard_CS_PORT                 PORTCbits.RC0
#define SDCard_CS_WPU                  WPUCbits.WPUC0
#define SDCard_CS_OD                   ODCONCbits.ODCC0
#define SDCard_CS_ANS                  ANSELCbits.ANSELC0
#define SDCard_CS_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define SDCard_CS_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define SDCard_CS_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define SDCard_CS_GetValue()           PORTCbits.RC0
#define SDCard_CS_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define SDCard_CS_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)
#define SDCard_CS_SetPullup()          do { WPUCbits.WPUC0 = 1; } while(0)
#define SDCard_CS_ResetPullup()        do { WPUCbits.WPUC0 = 0; } while(0)
#define SDCard_CS_SetPushPull()        do { ODCONCbits.ODCC0 = 0; } while(0)
#define SDCard_CS_SetOpenDrain()       do { ODCONCbits.ODCC0 = 1; } while(0)
#define SDCard_CS_SetAnalogMode()      do { ANSELCbits.ANSELC0 = 1; } while(0)
#define SDCard_CS_SetDigitalMode()     do { ANSELCbits.ANSELC0 = 0; } while(0)

// get/set RC1 procedures
#define RC1_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define RC1_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define RC1_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define RC1_GetValue()              PORTCbits.RC1
#define RC1_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define RC1_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)
#define RC1_SetPullup()             do { WPUCbits.WPUC1 = 1; } while(0)
#define RC1_ResetPullup()           do { WPUCbits.WPUC1 = 0; } while(0)
#define RC1_SetAnalogMode()         do { ANSELCbits.ANSELC1 = 1; } while(0)
#define RC1_SetDigitalMode()        do { ANSELCbits.ANSELC1 = 0; } while(0)

// get/set RC2 procedures
#define RC2_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define RC2_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define RC2_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define RC2_GetValue()              PORTCbits.RC2
#define RC2_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define RC2_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define RC2_SetPullup()             do { WPUCbits.WPUC2 = 1; } while(0)
#define RC2_ResetPullup()           do { WPUCbits.WPUC2 = 0; } while(0)
#define RC2_SetAnalogMode()         do { ANSELCbits.ANSELC2 = 1; } while(0)
#define RC2_SetDigitalMode()        do { ANSELCbits.ANSELC2 = 0; } while(0)

// get/set RC3 procedures
#define RC3_SetHigh()            do { LATCbits.LATC3 = 1; } while(0)
#define RC3_SetLow()             do { LATCbits.LATC3 = 0; } while(0)
#define RC3_Toggle()             do { LATCbits.LATC3 = ~LATCbits.LATC3; } while(0)
#define RC3_GetValue()              PORTCbits.RC3
#define RC3_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define RC3_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)
#define RC3_SetPullup()             do { WPUCbits.WPUC3 = 1; } while(0)
#define RC3_ResetPullup()           do { WPUCbits.WPUC3 = 0; } while(0)
#define RC3_SetAnalogMode()         do { ANSELCbits.ANSELC3 = 1; } while(0)
#define RC3_SetDigitalMode()        do { ANSELCbits.ANSELC3 = 0; } while(0)

// get/set XRST aliases
#define XRST_TRIS                 TRISCbits.TRISC4
#define XRST_LAT                  LATCbits.LATC4
#define XRST_PORT                 PORTCbits.RC4
#define XRST_WPU                  WPUCbits.WPUC4
#define XRST_OD                   ODCONCbits.ODCC4
#define XRST_ANS                  ANSELCbits.ANSELC4
#define XRST_SetHigh()            do { LATCbits.LATC4 = 1; } while(0)
#define XRST_SetLow()             do { LATCbits.LATC4 = 0; } while(0)
#define XRST_Toggle()             do { LATCbits.LATC4 = ~LATCbits.LATC4; } while(0)
#define XRST_GetValue()           PORTCbits.RC4
#define XRST_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define XRST_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)
#define XRST_SetPullup()          do { WPUCbits.WPUC4 = 1; } while(0)
#define XRST_ResetPullup()        do { WPUCbits.WPUC4 = 0; } while(0)
#define XRST_SetPushPull()        do { ODCONCbits.ODCC4 = 0; } while(0)
#define XRST_SetOpenDrain()       do { ODCONCbits.ODCC4 = 1; } while(0)
#define XRST_SetAnalogMode()      do { ANSELCbits.ANSELC4 = 1; } while(0)
#define XRST_SetDigitalMode()     do { ANSELCbits.ANSELC4 = 0; } while(0)

// get/set XDCS aliases
#define XDCS_TRIS                 TRISCbits.TRISC5
#define XDCS_LAT                  LATCbits.LATC5
#define XDCS_PORT                 PORTCbits.RC5
#define XDCS_WPU                  WPUCbits.WPUC5
#define XDCS_OD                   ODCONCbits.ODCC5
#define XDCS_ANS                  ANSELCbits.ANSELC5
#define XDCS_SetHigh()            do { LATCbits.LATC5 = 1; } while(0)
#define XDCS_SetLow()             do { LATCbits.LATC5 = 0; } while(0)
#define XDCS_Toggle()             do { LATCbits.LATC5 = ~LATCbits.LATC5; } while(0)
#define XDCS_GetValue()           PORTCbits.RC5
#define XDCS_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define XDCS_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)
#define XDCS_SetPullup()          do { WPUCbits.WPUC5 = 1; } while(0)
#define XDCS_ResetPullup()        do { WPUCbits.WPUC5 = 0; } while(0)
#define XDCS_SetPushPull()        do { ODCONCbits.ODCC5 = 0; } while(0)
#define XDCS_SetOpenDrain()       do { ODCONCbits.ODCC5 = 1; } while(0)
#define XDCS_SetAnalogMode()      do { ANSELCbits.ANSELC5 = 1; } while(0)
#define XDCS_SetDigitalMode()     do { ANSELCbits.ANSELC5 = 0; } while(0)

// get/set DREQ aliases
#define DREQ_TRIS                 TRISCbits.TRISC6
#define DREQ_LAT                  LATCbits.LATC6
#define DREQ_PORT                 PORTCbits.RC6
#define DREQ_WPU                  WPUCbits.WPUC6
#define DREQ_OD                   ODCONCbits.ODCC6
#define DREQ_ANS                  ANSELCbits.ANSELC6
#define DREQ_SetHigh()            do { LATCbits.LATC6 = 1; } while(0)
#define DREQ_SetLow()             do { LATCbits.LATC6 = 0; } while(0)
#define DREQ_Toggle()             do { LATCbits.LATC6 = ~LATCbits.LATC6; } while(0)
#define DREQ_GetValue()           PORTCbits.RC6
#define DREQ_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define DREQ_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)
#define DREQ_SetPullup()          do { WPUCbits.WPUC6 = 1; } while(0)
#define DREQ_ResetPullup()        do { WPUCbits.WPUC6 = 0; } while(0)
#define DREQ_SetPushPull()        do { ODCONCbits.ODCC6 = 0; } while(0)
#define DREQ_SetOpenDrain()       do { ODCONCbits.ODCC6 = 1; } while(0)
#define DREQ_SetAnalogMode()      do { ANSELCbits.ANSELC6 = 1; } while(0)
#define DREQ_SetDigitalMode()     do { ANSELCbits.ANSELC6 = 0; } while(0)

// get/set XCS aliases
#define XCS_TRIS                 TRISCbits.TRISC7
#define XCS_LAT                  LATCbits.LATC7
#define XCS_PORT                 PORTCbits.RC7
#define XCS_WPU                  WPUCbits.WPUC7
#define XCS_OD                   ODCONCbits.ODCC7
#define XCS_ANS                  ANSELCbits.ANSELC7
#define XCS_SetHigh()            do { LATCbits.LATC7 = 1; } while(0)
#define XCS_SetLow()             do { LATCbits.LATC7 = 0; } while(0)
#define XCS_Toggle()             do { LATCbits.LATC7 = ~LATCbits.LATC7; } while(0)
#define XCS_GetValue()           PORTCbits.RC7
#define XCS_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define XCS_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)
#define XCS_SetPullup()          do { WPUCbits.WPUC7 = 1; } while(0)
#define XCS_ResetPullup()        do { WPUCbits.WPUC7 = 0; } while(0)
#define XCS_SetPushPull()        do { ODCONCbits.ODCC7 = 0; } while(0)
#define XCS_SetOpenDrain()       do { ODCONCbits.ODCC7 = 1; } while(0)
#define XCS_SetAnalogMode()      do { ANSELCbits.ANSELC7 = 1; } while(0)
#define XCS_SetDigitalMode()     do { ANSELCbits.ANSELC7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/